import BatchUpdateHost from "./BatchUpdateHost";
import { AnyStoreDeclarer } from "./StoreDeclarer";
import RecycleStrategy from "./RecycleStrategy";
import DispatchItem from "./DispatchItem";
import DispatchParent from "./DispatchParent";
import { Emitter } from "event-kit";
export default class AppStore implements DispatchParent {
    _isInit: boolean;
    batchUpdater: BatchUpdateHost;
    prevState: any;
    state: any;
    stores: {
        [storeKey: string]: DispatchItem;
    };
    _emitter: Emitter<{
        [key: string]: any;
    }, {}>;
    _storeRegisterMap: {
        [storeName: string]: AnyStoreDeclarer;
    };
    _cycleCollections: Set<string>[] | undefined;
    _recycleStrategy: RecycleStrategy;
    _depStoreList: {
        [storeName: string]: string[];
    };
    __initStates__: any;
    static isAppStore: Function;
    constructor(storeDeclarers?: AnyStoreDeclarer[] | {
        [key: string]: any;
    }, initStates?: any);
    setState(state: any): void;
    _sendUpdate(): void;
    forceUpdate(): void;
    handleWillChange(prevState: any, state: any): void;
    onDidChange(callback: (state: any) => void): import("event-kit").Disposable;
    preloadStores(stores: string[], lifetime?: "static" | "dynamic"): Promise<void[]>;
    preloadStaticStores(): Promise<void[]>;
    init(): this;
    dispose(): void;
    onDidChangeRS(callback: (recycleStrategy: RecycleStrategy) => void): import("event-kit").Disposable;
    setRecycleStrategy(recycleStrategy: RecycleStrategy): void;
    /**
     * Register the store into the appStore with storeDeclarer
     * @param storeDeclarer: AnyStoreDeclater
     */
    registerStore(...storeDeclarers: AnyStoreDeclarer[]): void;
    /**
     * Request the appStore to create store by the storeKey if this store has exists and add reference to 1
     * Request the appStore to add reference count if this store has exists.
     * @param storeKey
     */
    requestStore(storeKey: string, storeOpts?: any): DispatchItem;
    /**
     * Release the store reference count with name of storeKey, if the reference count decrease to 0, then the store destroy.
     * @param storeKey
     */
    releaseStore(storeKey: string, storeOpts?: any): void;
    _createStoreAndInject(storeKey: string, storeOpts?: any): string[];
    _disposeStoreAndDeps(storeKey: string, store: DispatchItem, storeOpts?: any): void;
    _getStoreKey(storeKey: string, storeOpts?: any): string;
    _parseStoreKey(finalStoreKey: string): [string, any];
    _getStateKey(storeKey: string, stateKey: string, storeOpts?: any): string;
    _createStore(storeKey: string, store: DispatchItem, storeOpts?: any): void;
    _deleteStore(storeKey: string, storeOpts?: any): void;
}
