"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var BatchUpdateHost = /** @class */ (function () {
    function BatchUpdateHost(appStore) {
        this.runState = "idle";
        this.appStore = appStore;
    }
    // The AppStore need to update the state
    BatchUpdateHost.prototype.requestUpdate = function () {
        var _this = this;
        if (this.runState === "idle") {
            this.runState = "prepare";
            // Collect all of the update request and update AppStore After 20ms
            if (typeof requestIdleCallback !== "undefined") {
                requestIdleCallback(function () { return _this.runUpdate(); });
            }
            else {
                setTimeout(function () { return _this.runUpdate(); }, 0);
            }
        }
    };
    BatchUpdateHost.prototype.runUpdate = function () {
        this.runState = "idle";
        this.appStore._sendUpdate(); //enable appStore update
    };
    return BatchUpdateHost;
}());
exports.default = BatchUpdateHost;
