export declare class LRUNode<T> {
    key: string;
    value: T;
    prev: LRUNode<T> | undefined;
    next: LRUNode<T> | undefined;
    constructor(key: string, value: T, next?: LRUNode<T>, prev?: LRUNode<T>);
}
declare type OnExceedRemove = (key: string) => void;
export default class LRU<T> {
    size: number;
    limit: number;
    head: LRUNode<T> | undefined;
    tail: LRUNode<T> | undefined;
    cache: {
        [key: string]: any;
    };
    onExceedRemove: undefined | OnExceedRemove;
    constructor(limit?: number, onExceedRemove?: (key: string) => void);
    put(key: string, value: T): void;
    take(key: string): any;
    get(key: string): any;
    ensureLimit(): void;
    remove(key: string): void;
    clear(): void;
    forEach(fn: (node: LRUNode<T>, index: number) => void): void;
    [Symbol.iterator](): Generator<LRUNode<T>, void, unknown>;
}
export {};
