"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var _a, _b, _c;
Object.defineProperty(exports, "__esModule", { value: true });
var StoreList_1 = require("./StoreList");
var StoreMap_1 = require("./StoreMap");
var StoreReg = /(\w+)Store$/;
function genDefaultStoreKey(StoreClass, options) {
    if (!options)
        options = {};
    if (!options.stateKey) {
        var storeName = options.storeKey || StoreClass.name;
        var regRes = StoreReg.exec(storeName);
        var stateKey = regRes ? regRes[1] : storeName;
        options.stateKey = stateKey[0].toLowerCase() + stateKey.slice(1);
    }
    if (!options.storeKey) {
        options.storeKey = options.stateKey + "Store";
    }
    return options;
}
function parseOptions(Store, depStoreNames, options) {
    if (Array.isArray(depStoreNames)) {
        options = genDefaultStoreKey(Store, options);
    }
    else {
        options = genDefaultStoreKey(Store, depStoreNames);
        depStoreNames = [];
    }
    return [depStoreNames, options];
}
var IS_STORE = "@@__STORE_ITEM__@@";
var StoreDeclarer = /** @class */ (function () {
    function StoreDeclarer(Store, depStoreNames, options) {
        this[_a] = true;
        this.Store = Store;
        var _d = __read(parseOptions(Store, depStoreNames, options), 2), names = _d[0], storeOptions = _d[1];
        this.depStoreNames = names;
        this.options = storeOptions;
    }
    StoreDeclarer.prototype.create = function (appStore) {
        return new this.Store();
    };
    StoreDeclarer.isStore = function (maybeStore) {
        return !!(maybeStore && maybeStore[IS_STORE]);
    };
    return StoreDeclarer;
}());
exports.StoreDeclarer = StoreDeclarer;
_a = IS_STORE;
function declareStore(Store, depStoreNames, options) {
    return new StoreDeclarer(Store, depStoreNames, options);
}
exports.declareStore = declareStore;
var IS_STORE_LIST = "@@__STORE_LIST__@@";
var StoreListDeclarer = /** @class */ (function () {
    function StoreListDeclarer(Store, depStoreNames, options) {
        this[_b] = true;
        this.Store = Store;
        var _d = __read(parseOptions(Store, depStoreNames, options), 2), names = _d[0], storeOptions = _d[1];
        this.depStoreNames = names;
        this.options = storeOptions;
    }
    StoreListDeclarer.prototype.create = function (appStore) {
        var ListClass = this.options.StoreList || StoreList_1.default;
        return new ListClass();
    };
    StoreListDeclarer.isStoreList = function (maybeList) {
        return !!(maybeList && maybeList[IS_STORE_LIST]);
    };
    return StoreListDeclarer;
}());
exports.StoreListDeclarer = StoreListDeclarer;
_b = IS_STORE_LIST;
function declareStoreList(Store, depStoreNames, options) {
    return new StoreListDeclarer(Store, depStoreNames, options);
}
exports.declareStoreList = declareStoreList;
var IS_STORE_MAP = "@@__STORE_MAP__@@";
var StoreMapDeclarer = /** @class */ (function () {
    function StoreMapDeclarer(Store, depStoreNames, options) {
        this[_c] = true;
        this.Store = Store;
        var _d = __read(parseOptions(Store, depStoreNames, options), 2), names = _d[0], storeOptions = _d[1];
        this.depStoreNames = names;
        this.options = storeOptions;
    }
    StoreMapDeclarer.prototype.create = function (appStore) {
        var MapClass = this.options.StoreMap || StoreMap_1.default;
        return new MapClass();
    };
    StoreMapDeclarer.isStoreMap = function (maybeMap) {
        return !!(maybeMap && maybeMap[IS_STORE_MAP]);
    };
    return StoreMapDeclarer;
}());
exports.StoreMapDeclarer = StoreMapDeclarer;
_c = IS_STORE_MAP;
function declareStoreMap(Store, depStoreNames, options) {
    return new StoreMapDeclarer(Store, depStoreNames, options);
}
exports.declareStoreMap = declareStoreMap;
