import StoreBase from "./StoreBase";
import { StoreBaseConstructor, StoreListDeclarerOptions } from "./StoreDeclarer";
import DispatchItem from "./DispatchItem";
import DispatchParent from "./DispatchParent";
export default class StoreList<T> implements DispatchItem {
    length: number;
    storeArray: StoreBase<T>[];
    _options: StoreListDeclarerOptions | undefined;
    _StoreBuilder: StoreBaseConstructor<T> | undefined;
    _depStores: {
        [storeKey: string]: DispatchItem;
    };
    _stateKey: string | undefined;
    _appStore: DispatchParent | undefined;
    _refCount: number;
    __initStates__: any;
    state: any;
    _init(): void | Promise<[void[] | undefined, void]>;
    init(): void;
    _inject(appStore: DispatchParent | undefined, StoreBuilder: StoreBaseConstructor<T>, stateKey?: string, depStores?: {
        [storeKey: string]: DispatchItem;
    }, initState?: any, options?: StoreListDeclarerOptions): void;
    setInitStates(initStates: any): void;
    setSize(count: number): Promise<void[]> | undefined;
    setState(state: any): void;
    dispose(): void;
    forEach(callback: (value: StoreBase<T>, index: number, array: StoreBase<T>[]) => void): void;
    map(callback: (value: StoreBase<T>, index: number, array: StoreBase<T>[]) => any): any[];
    filter(callback: (value: StoreBase<T>, index: number, array: StoreBase<T>[]) => boolean): StoreBase<T>[];
    get(index: number): StoreBase<T>;
    slice(begin: number, end: number): StoreBase<T>[];
    indexOf(item: StoreBase<T>): number;
    _addRef(): void;
    _decreaseRef(): void;
    getRefCount(): number;
}
