import { StoreMapDeclarerOptions, StoreBaseConstructor } from "./StoreDeclarer";
import DispatchItem from "./DispatchItem";
import DispatchParent from "./DispatchParent";
import { DisposableLike, CompositeDisposable, Emitter } from "event-kit";
import RecycleStrategy from "./RecycleStrategy";
import LRU from "./LRU";
export declare enum OperateMode {
    None = 0,
    Direct = 1,
    RefCount = 2
}
export declare class OperateModeSwitch {
    operateMode: OperateMode;
    enterRefCountMode(): void;
    enterDirectMode(): void;
}
export default class StoreMap<T> implements DispatchItem {
    storeMap: Map<string, any>;
    _options: StoreMapDeclarerOptions | undefined;
    _StoreBuilder: StoreBaseConstructor<T> | undefined;
    _depStores: {
        [storeKey: string]: DispatchItem;
    };
    _stateKey: string | undefined;
    _recycleStrategy: RecycleStrategy | undefined;
    _keyCache: LRU<string> | undefined;
    _appStore: DispatchParent | undefined;
    _refCount: number;
    emitter: Emitter<{
        [key: string]: any;
    }, {}>;
    __initStates__: any;
    state: any;
    _keyRefs: {
        [key: string]: number;
    };
    disposables: CompositeDisposable;
    operateModeSwitch: OperateModeSwitch;
    _init(): void | Promise<void[]>;
    init(): void;
    _inject(appStore: DispatchParent | undefined, StoreBuilder: StoreBaseConstructor<T>, stateKey?: string, depStores?: {
        [storeKey: string]: DispatchItem;
    }, initState?: any, options?: StoreMapDeclarerOptions): void;
    _disposeSubStores(): void;
    onDidChangeRS(callback: (recycleStrategy: RecycleStrategy) => void): import("event-kit").Disposable;
    observeRS(callback: (recycleStrategy: RecycleStrategy) => void): import("event-kit").Disposable;
    setRecycleStrategy(recycleStrategy: RecycleStrategy, options?: {
        cacheLimit: number | undefined;
    }): void;
    setInitStates(initStates: any): void;
    requestStore(storeKey: string): void;
    releaseStore(storeKey: string): void;
    request(keys: string | string[]): DisposableLike;
    _addOne(key: string): void | Promise<void>;
    _deleteOne(key: string): void;
    add(key: string | string[]): void;
    delete(key: string | string[]): void;
    clear(): void;
    setState(state: any): void;
    dispose(): void;
    forEach(callback: (value: any, key: string, map: Map<string, any>) => void): void;
    get(key: string): any;
    has(key: string): boolean;
    keys(): IterableIterator<string>;
    values(): IterableIterator<any>;
    entries(): IterableIterator<[string, any]>;
    _addRef(): void;
    _decreaseRef(): void;
    getRefCount(): number;
}
