"use strict";
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
function depthSearchStore(storeKey, storeVisits, storeMap, visitStoreList, visitStoreSet, cycleDepList) {
    var e_1, _a;
    if (!storeMap[storeKey])
        return;
    storeVisits[storeKey] = true;
    visitStoreList.push(storeKey);
    visitStoreSet.add(storeKey);
    var depNames = storeMap[storeKey].depStoreNames || [];
    try {
        for (var depNames_1 = __values(depNames), depNames_1_1 = depNames_1.next(); !depNames_1_1.done; depNames_1_1 = depNames_1.next()) {
            var depName = depNames_1_1.value;
            // We encounter the depName that has in the visit store list.
            if (visitStoreSet.has(depName)) {
                var namePos = visitStoreList.indexOf(depName);
                var visits = visitStoreList.slice(namePos).sort();
                var cycleKey = visits.join(",");
                if (!cycleDepList[cycleKey]) {
                    cycleDepList[cycleKey] = new Set(visits);
                }
                continue;
            }
            if (storeVisits[depName])
                continue;
            depthSearchStore(depName, storeVisits, storeMap, visitStoreList, visitStoreSet, cycleDepList);
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (depNames_1_1 && !depNames_1_1.done && (_a = depNames_1.return)) _a.call(depNames_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    visitStoreList.pop();
    visitStoreSet.delete(storeKey);
    storeVisits[storeKey] = false;
}
function searchCycleCollection(storeMap) {
    var storeVisits = {};
    for (var storeKey in storeMap) {
        storeVisits[storeKey] = false;
    }
    var cycleDepList = {};
    for (var storeKey in storeMap) {
        if (!storeVisits[storeKey]) {
            depthSearchStore(storeKey, storeVisits, storeMap, [], new Set(), cycleDepList);
        }
    }
    return Object.values(cycleDepList);
}
exports.default = searchCycleCollection;
